一个 Promise 就是一个代表了异步操作最终完成或者失败的对象.  一个promise可以使用它的constructor创建。然而,大多数人都在使用由其他函数创建并返回的promise。因此,本教程将首先探讨返回promise的使用情况。

本质上,一个promise是某个函数返回的对象,你可以把回调函数绑定在这个对象上,而不是把回调函数当作参数传进函数。 

比如,promise替代了下面这种旧式的函数,这种旧式函数需要两个回调函数,并最终调用处理成功事件或者处理失败事件的回调函数:

function successCallback(result) {
  console.log("It succeeded with " + result);
}

function failureCallback(error) {
  console.log("It failed with " + error);
}

doSomething(successCallback, failureCallback);

...新式函数返回一个你可以直接绑定回调函数的promise对象,来代替旧式的函数形式:

let promise = doSomething(); 
promise.then(successCallback, failureCallback);

…或者更简单的形式:

doSomething().then(successCallback, failureCallback);

我们把这个称为异步函数调用,这种形式有若干优点。我们将会逐一讨论。

保证

不像旧式函数那样传递回调函数,promise会带来一些保证:

  • 在JavaScript事件队列的当前运行完成之前,回调函数永远不会被调用。
  • 通过.then形式添加的回调函数,甚至都在异步操作完成之后才被添加的函数,都会被调用,如上所示。
  • 通过多次调用.then,可以添加多个回调函数,它们会按照插入顺序并且独立运行。

但是,promise最直接的好处就是链式调用。

链式调用

一个常见的需求就是连续执行两个或者多个异步操作,这种情况下,每一个后来的操作都在前面的操作执行成功之后,带着上一步操作所返回的结果开始执行。我们可以通过创造一个promise chain来完成这种需求。

见证奇迹的时刻:then函数会返回一个新的promise,跟原来的不同:

const promise = doSomething();
const promise2 = promise.then(successCallback, failureCallback);

或者

let promise2 = doSomething().then(successCallback, failureCallback);

第二个promise不仅代表doSomething()函数的完成,也代表了你传入的 successCallback 或者failureCallback 的完成,这也可能是其他异步函数返回的promise。这样的话,任何被添加给 promise2 的回调函数都会被排在 successCallback 或 failureCallback 返回的promise后面。

基本上,每一个promise代表了链式中另一个异步过程的完成。

在过去,做多重的异步操作,会导致经典的回调金字塔厄运 (回调地狱):

doSomething(function(result) {
  doSomethingElse(result, function(newResult) {
    doThirdThing(newResult, function(finalResult) {
      console.log('Got the final result: ' + finalResult);
    }, failureCallback);
  }, failureCallback);
}, failureCallback);

通过现代的函数,我们把回调附加到被返回的promise上代替以往的做法,形成一个promise chain:

doSomething().then(function(result) {
  return doSomethingElse(result);
})
.then(function(newResult) {
  return doThirdThing(newResult);
})
.then(function(finalResult) {
  console.log('Got the final result: ' + finalResult);
})
.catch(failureCallback);

then里的参数是可选的,catch(failureCallback) 是 then(null, failureCallback) 的缩略形式。如下所示,也可以用 arrow functions(箭头函数)来表示:

doSomething()
.then(result => doSomethingElse(result))
.then(newResult => doThirdThing(newResult))
.then(finalResult => {
  console.log(`Got the final result: ${finalResult}`);
})
.catch(failureCallback);

注意:一定要返回promise,不然的话回调不会形成链式,错误也获取不到(当省略{}时,箭头函数将隐式返回)。

catch之后的链式操作

在一个失败操作(即一个 catch)之后可以继续使用链式操作,即使链式中的一个动作失败之后还能有助于新的动作继续完成。请阅读下面的例子:

new Promise((resolve, reject) => {
    console.log('Initial');

    resolve();
})
.then(() => {
    throw new Error('Something failed');
        
    console.log('Do this');
})
.catch(() => {
    console.log('Do that');
})
.then(() => {
    console.log('Do this whatever happened before');
});

输出结果如下:

Initial
Do that
Do this whatever happened before

注意,由于“Something failed”错误导致了拒绝操作,所以“Do this”文本没有被输出。

错误传播

在之前的回调厄运示例中,你可能记得有3次failureCallback的调用,而在promise链式中只有底部的一次调用

doSomething()
.then(result => doSomethingElse(value))
.then(newResult => doThirdThing(newResult))
.then(finalResult => console.log(`Got the final result: ${finalResult}`))
.catch(failureCallback);

基本上,一个promise链式遇到异常就会停止,查看链式的底端,寻找catch处理程序来代替当前执行。在同步的代码执行之后,这是非常模型化的。

try {
  let result = syncDoSomething();
  let newResult = syncDoSomethingElse(result);
  let finalResult = syncDoThirdThing(newResult);
  console.log(`Got the final result: ${finalResult}`);
} catch(error) {
  failureCallback(error);
}

在ECMAScript 2017标准的async/await语法糖中,这种同步形式代码的整齐性得到了极致的体现:

async function foo() {
  try {
    let result = await doSomething();
    let newResult = await doSomethingElse(result);
    let finalResult = await doThirdThing(newResult);
    console.log(`Got the final result: ${finalResult}`);
  } catch(error) {
    failureCallback(error);
  }
}

这个例子是在promise的基础上构建的,例如,doSomething()与之前的函数是相同的。你可以阅读更多的与这个语法相关的文章:点这里

通过捕获所有的错误,甚至抛出异常和程序错误,promise解决了回调厄运金字塔的基本缺陷。这是异步操作的基本功能。

在一个旧的API回调中创建promise

 Promise通过它的构造器从头开始创建。 只需要包裹旧的API就行了。

理想状态下,所有的异步函数都已经返回promise了。但有一些API仍然使用旧式的被传入的成功或者失败的回调。典型的例子就是setTimeout()函数:

setTimeout(() => saySomething("10 seconds passed"), 10000);

混合旧式回调和promise是会有问题的。如果 saySomething  函数失败了或者包含了编程错误,那就没有办法捕获它了。

幸运的是我们可以用promise来包裹它。最佳实践是在尽可能底层的地方来包裹有问题的函数,并且永远不要再直接调用它们:

const wait = ms => new Promise(resolve => setTimeout(resolve, ms));

wait(10000).then(() => saySomething("10 seconds")).catch(failureCallback);

通常,promise的构造器会有一个可以让我们手动操作resolve和reject的执行函数。既然 setTimeout 没有真的执行失败,那么我们可以在这种情况下忽略reject。

组成

Promise.resolve()Promise.reject() 是手动创建一个已经resolve或者reject的promise快捷方法。它们有时很有用。

Promise.all()Promise.race()是并行运行异步操作的两个组合式工具。

时序组合可以使用一些优雅的javascript形式:

[func1, func2].reduce((p, f) => p.then(f), Promise.resolve());

通常,我们递归调用一个由异步函数组成的数组时相当于一个promise链式:Promise.resolve().then(func1).then(func2);

我们也可以写成可复用的函数形式,这在函数式编程中极为普遍:

let applyAsync = (acc,val) => acc.then(val);
let composeAsync = (...funcs) => x => funcs.reduce(applyAsync, Promise.resolve(x));

composeAsync函数将会接受任意数量的函数作为其参数,并返回一个新的函数,该函数接受一个通过composition pipeline传入的初始值。这对我们来说非常有益,因为任一函数可以是异步或同步的,它们能被保证按顺序执行:

let transformData = composeAsync(func1, asyncFunc1, asyncFunc2, func2);
transformData(data);

在 ECMAScript 2017标准中, 时序组合可以通过使用async/await而变得更简单:

for (let f of [func1, func2]) {
  await f();
}

Timing

为了避免意外,传递给then的函数永远不要再同步调用,即使它是一个已经变成resolve状态的promise:

Promise.resolve().then(() => console.log(2));
console.log(1); // 1, 2

传递到then中的函数被置入了一个微任务队列,而不是立即执行,这意味着它是在JavaScript事件队列的所有运行时结束了,事件队列被清空之后才开始执行:

const wait = ms => new Promise(resolve => setTimeout(resolve, ms));

wait().then(() => console.log(4));
Promise.resolve().then(() => console.log(2)).then(() => console.log(3));
console.log(1); // 1, 2, 3, 4

参见:

文档标签和贡献者

 此页面的贡献者: vanishcode, winjeysong, cwc7233, TimmyKingFree
 最后编辑者: vanishcode,